package org.antlr.analysis;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import org.antlr.analysis.DFA;
import org.antlr.analysis.SemanticContext;
import org.antlr.codegen.CodeGenerator;
import org.antlr.tool.Grammar;
import org.stringtemplate.v4.ST;
import org.stringtemplate.v4.STGroup;

public class NOT extends SemanticContext {
  protected SemanticContext ctx;
  
  public NOT(SemanticContext ctx) {
    this.ctx = ctx;
  }
  
  public ST genExpr(CodeGenerator generator, STGroup templates, DFA dfa) {
    ST eST;
    if (templates != null) {
      eST = templates.getInstanceOf("notPredicate");
    } else {
      eST = new ST("!(<pred>)");
    } 
    eST.add("pred", this.ctx.genExpr(generator, templates, dfa));
    return eST;
  }
  
  public SemanticContext getGatedPredicateContext() {
    SemanticContext p = this.ctx.getGatedPredicateContext();
    if (p == null)
      return null; 
    return new NOT(p);
  }
  
  public boolean hasUserSemanticPredicate() {
    return this.ctx.hasUserSemanticPredicate();
  }
  
  public boolean isSyntacticPredicate() {
    return this.ctx.isSyntacticPredicate();
  }
  
  public void trackUseOfSyntacticPredicates(Grammar g) {
    this.ctx.trackUseOfSyntacticPredicates(g);
  }
  
  public boolean equals(Object object) {
    if (!(object instanceof NOT))
      return false; 
    return this.ctx.equals(((NOT)object).ctx);
  }
  
  public int hashCode() {
    return this.ctx.hashCode() ^ 0xFFFFFFFF;
  }
  
  public String toString() {
    return "!(" + this.ctx + ")";
  }
}
